WEBHDFS_SPEC = {
    'put': {'method': 'put',
            'path': '/{file_path}',
            'stream_request': True,
            'query_params': {'op': 'CREATE'}},
    'append': {'method': 'post',
               'path': '/{file_path}',
               'stream_request': True,
               'query_params': {'op': 'APPEND'}},
    'get': {'method': 'get',
            'path': '/{file_path}',
            'stream_response': True,
            'query_params': {'op': 'OPEN'}},
    'mkdir': {'method': 'put',
              'path': '/{file_path}',
              'query_params': {'op': 'MKDIRS'}},
    'move': {'method': 'put',
             'path': '/{file_path}',
             'query_params': {'op': 'RENAME'}},
    'remove': {'method': 'DELETE',
               'path': '/{file_path}',
               'query_params': {'op': 'DELETE'}},
    'get_file_status': {'method': 'get',
                        'path': '/{file_path}',
                        'query_params': {'op': 'GETFILESTATUS'}},
    'list_dir': {'method': 'get',
                 'path': '/{file_path}',
                 'query_params': {'op': 'LISTSTATUS'}},
    'get_content_summary': {'method': 'get',
                            'path': '/{file_path}',
                            'query_params': {'op': 'GETCONTENTSUMMARY'}},
    'get_file_checksum': {'method': 'get',
                          'path': '/{file_path}',
                          'query_params': {'op': 'GETFILECHECKSUM'}},
    'get_home_directory': {'method': 'get',
                           'path': '',
                           'query_params': {'op': 'GETHOMEDIRECTORY'}},
    'chmod': {'method': 'put',
              'path': '/{file_path}',
              'query_params': {'op': 'SETPERMISSION'}},
    'chown': {'method': 'put',
              'path': '/{file_path}',
              'query_params': {'op': 'SETOWNER'}},
    'set_replication': {'method': 'put',
                        'path': '/{file_path}',
                        'query_params': {'op': 'SETREPLICATION'}},
    'set_times': {'method': 'put',
                  'path': '/{file_path}',
                  'query_params': {'op': 'SETTIMES'}},
}
